module Classify3
  class Bayes
    def initialize
      @rust = Classify3::Rust::Binding.new
    end

    def add(doc, label)
      @rust.add(doc, label)
    end

    def train
      @rust.train
    end

    def classify(str)
      @rust.classify(str)
    end
  end

  class Rust < FFI::AutoPointer
    def self.release(ptr)
      Binding.free(ptr)
    end

    def add(doc, label)
      Binding.add(self, doc, label)
    end

    def train
      Binding.train(self)
    end

    def classify(str)
      Binding.classify(self, str)
    end
    
    module Binding
      extend FFI::Library
      ffi_lib './ffi/libclassify3.so'

      attach_function :new, :bayes_new, [], Rust
      attach_function :free, :bayes_free, [Rust], :void
      attach_function :add, :bayes_add, [Rust, :string, :string], :void
      attach_function :train, :bayes_train, [Rust], :void
      attach_function :classify, :bayes_classify, [Rust, :string], :string
    end
  end
end
